package org.rcisoft.business.jzmessage.service;


import org.activiti.engine.runtime.ProcessInstance;
import org.activiti.model.CyPIAndTaskModel;
import org.activiti.service.CyWfService;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.core.model.CyCommonPageGridModel;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtil;
import org.rcisoft.core.result.CyResult;
import org.rcisoft.sys.dept.entity.SysDept;
import org.rcisoft.sys.user.entity.SysUser;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * Created by lpy on 2019-7-24 17:40:17.
 */
public interface JzMessageService {

    /**
    * 保存 基站信息表
    * @param jzMessage
    * @return
    */
    CyPersistModel save(JzMessage jzMessage);

    /**
    * 删除 基站信息表
    * @param jzMessage
    * @return
    */
    CyPersistModel remove(JzMessage jzMessage);
    /**
    * 逻辑删除 基站信息表
    * @param jzMessage
    * @return
    */
    CyPersistModel removeLogical(JzMessage jzMessage);
    /**
    * 修改 基站信息表
    * @param jzMessage
    * @return
    */
    CyPersistModel merge(JzMessage jzMessage);

    /**
    * 根据id查询 基站信息表
    * @param id
    * @return
    */
    JzMessage findById(String id);

    /**
    * 分页查询 基站信息表
    * @param jzMessage
    * @return
    */
    List<JzMessage> findAllByPagination(CyPageUtil<JzMessage> paginationUtility,
                                        JzMessage jzMessage, List<SysDept> deptList);


    /**
    * 查询list 基站信息表
    * @param jzMessage
    * @return
    */
    List<JzMessage> findAll(JzMessage jzMessage);


    /**
     * 完成任务
     * @return
     */
    CyPersistModel completeTask(JzMessage jzMessage);

    /**
     * 判断是不是自己的有业务
     * @return
     */
    CyCommonPageGridModel dealwith(CyGridModel cyGridModel);


    /**
     * 基站信息excl导出
     * @param response
     * @param jzMessage
     */
    HSSFWorkbook exportExcl(HttpServletResponse response, JzMessage jzMessage, List<SysDept> deptList) throws IOException;

    /**
     * 批量查入
     * @param jzMessagesList
     * @return
     */
    CyPersistModel batchSave(List<JzMessage> jzMessagesList);

    /**
     * 金蝶添加
     * @param jzMessage
     * @return
     */
    CyPersistModel KingDeeSave(JzMessage jzMessage);
    /**
     * 测试启动
     */
    CyPersistModel startProcessInstance(JzMessage jzMessage);
    /**
     *
     * 三级经理更换业务员
     */
    CyPersistModel changeUser(String jzMessageId,String userId);

    /**
     * 根据id查询 基站信息
     * @param id
     * @return
     */
     String findJzMessage(String id);

    /**
     * 登陆成功mid
     * @param mid
     * @return
     */
    String loginSuccess(String mid,String key);

    /**
     * 判断当前基站是否处于更换阶段负责人状态
     * @param jzMessage
     * @return
     */
    CyResult isChangeUserInProcess(JzMessage jzMessage);

    /**
     * 取消需求取消
     * @param jzMessage
     * @return
     */
    CyResult cancelNeed(JzMessage jzMessage);
}
