package org.rcisoft.business.kingdee.until;

/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 11:16  2019/9/11
 * @Modified By:
 */

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import io.swagger.models.auth.In;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.sdictionary.service.impl.SDictionaryServiceImpl;
import org.rcisoft.core.service.CyBaseService;
import org.springframework.beans.factory.annotation.Autowired;
import sun.rmi.runtime.Log;

import java.util.*;

/**
 * @date 2019/1/7 15:58
 */
@Slf4j
public class BaseUtil {


    private BaseUtil() {
    }

    ;

    /**
     * 构造登录参数
     *
     * @param dbid     账套id
     * @param userName 用户名
     * @param password 密码
     * @param lang     语言
     * @return
     */
    public static String buildLogin(String dbid, String userName, String password, int lang) {
        Map<String, Object> param = new HashMap<>(4);
        param.put("acctID", dbid);
        param.put("username", userName);
        param.put("password", password);
        param.put("lcid", lang);
        return JSON.toJSONString(param);

    }


    /**
     * @param template 基础数据模板
     * @param formid   表单id
     * @param template 模板
     * @return
     */
    public static String buildMaterial(String template, JzMessage jzMessage, String formid) {
        Map<String, Object> map = KingdeeStatusMap.KingDeeStatus(jzMessage.getJzType());
        Set<String> set = map.keySet();
        JSONObject basic = JSON.parseObject(template);
        Map<String, Object> model = (Map<String, Object>) basic.get("Model");
        if (StringUtils.isNotEmpty(jzMessage.getKingId())) {
            model.put("FID", Integer.parseInt(jzMessage.getKingId()));
        }
        //获取站点状态
        for (String state : set) {
            if (state.equals(jzMessage.getJzState())) {
                Map f_bfSiteState = (Map) model.get("F_SiteState");
                f_bfSiteState.put("FNUMBER", map.get(state));
                Map f_SiteState = (Map) model.get("F_SiteState");
                f_SiteState.put("FNUMBER", map.get(state));
            }
        }
        //获取区域
        Map f_area = (Map) model.get("F_Area");
        f_area.put("FNUMBER", jzMessage.getJzQy());
        log.error("111111111111111111111111111111111"+f_area);
        for (String s : SDictionaryServiceImpl.kingDeeDeptMap.keySet()) {
           if (s.equals(jzMessage.getJzCurDept())) {
               //获取业务组织必填
               Map f_dxmOrgId = (Map) model.get("F_DXMOrgId");
               f_dxmOrgId.put("FNumber", SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().substring(0,  SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().indexOf(",")));
               //获取三级部门
               Map f_department = (Map) model.get("F_Department");
               f_department.put("FNUMBER", SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().substring( SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().indexOf(",") + 1));
               break;
           }
        }
        //获取修改时间
        model.put("F_UpdateTime", PropertiesUtils.kingDeeTime(jzMessage.getUpdateDate()));
        //获取项目编号
        Map f_projectID = (Map) model.get("F_ProjectID");
        f_projectID.put("FNUMBER", jzMessage.getProjectCode());
       /* model.put("F_SiteName", jzMessage.getJzName());
        model.put("F_SiteAddress", jzMessage.getProjectAddress());
        model.put("F_SiteId", jzMessage.getJzCode());*/
        for (String user: SDictionaryServiceImpl.kingDeeUserMap.keySet()) {
            if (user.equals(jzMessage.getJzCurUser())) {
                //获取业务员1
                Map f_businessMan = (Map) model.get("F_BusinessMan");
                f_businessMan.put("FSTAFFNUMBER", SDictionaryServiceImpl.kingDeeUserMap.get(user).toString());
                break;
            }
        }
        for (String user: SDictionaryServiceImpl.kingDeeUserMap.keySet()) {
            if (user.equals(jzMessage.getJzProjectOwner())) {
                //获取三级经理
                Map f_threeManager = (Map) model.get("F_ThreeManager");
                f_threeManager.put("FSTAFFNUMBER", SDictionaryServiceImpl.kingDeeUserMap.get(user).toString());
                break;
            }
        }

        //获取修改人
        Map f_upadateMan = (Map) model.get("F_UpadateMan");
        f_upadateMan.put("FSTAFFNUMBER", jzMessage.getUpdateBy());
        //获取业务线
        Map f_businessLine = (Map) model.get("F_BusinessLine");
        f_businessLine.put("FNUMBER", jzMessage.getBusinessLine());
        //获取创建人
        Map fCreatorId = (Map) model.get("FCreatorId");
        fCreatorId.put("FUserID", jzMessage.getCreateBy());
        //获取创建时间
        model.put("FCreateDate", PropertiesUtils.kingDeeTime(jzMessage.getCreateDate()));
        //获取修改人
        Map fModifierId = (Map) model.get("FModifierId");
        fModifierId.put("FUserID", jzMessage.getUpdateBy());
        //获取修改时间
        model.put("FModifyDate", PropertiesUtils.kingDeeTime(jzMessage.getUpdateDate()));
        basic.put("Model", model);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("formid", formid);
        jsonObject.put("data", JSON.toJSONString(basic));
        return JSON.toJSONString(jsonObject);
    }

    /**
     * @param
     * @return
     * @author: jiangpengpeng
     * @description: 项目编号模板
     * @date: 2019/9/18 18:10
     */
    public static String buildProjectCode(String template, JzMessage jzMessage, String formid) {
        JSONObject basic = JSON.parseObject(template);
        Map<String, Object> model = (Map<String, Object>) basic.get("Model");
        if (StringUtils.isNotEmpty(jzMessage.getProjectCodeId())) {
            model.put("FID", Integer.parseInt(jzMessage.getProjectCodeId()));
        }
        //设置项目编号
        model.put("FNumber",jzMessage.getProjectCode());
        Set<String> set = SDictionaryServiceImpl.kingDeeDeptMap.keySet();
        for (String s : set) {
            if (s.equals(jzMessage.getJzCurDept())) {
                //设置创建组织 默认为广厦
                Map fCreateOrgId = (Map) model.get("FCreateOrgId");
                fCreateOrgId.put("FNumber",SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().substring(0,SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().indexOf(",")));
                //设置使用组织 默认为广厦
                Map fUseOrgId = (Map) model.get("FUseOrgId");
                fUseOrgId.put("FNumber",SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().substring(0,SDictionaryServiceImpl.kingDeeDeptMap.get(s).toString().indexOf(",")));
                break;
            }
        }
        if (jzMessage.getJzName().length()>50){
            jzMessage.setJzName(jzMessage.getJzName().substring(0,50));
        }
        if (jzMessage.getJzCode().length()>50){
            jzMessage.setJzCode(jzMessage.getJzCode().substring(0,50));
        }
        //设置name
        model.put("FName",jzMessage.getJzName());
        //设置基站name
        model.put("FStoName",jzMessage.getJzName());
        //设置基站号
        model.put("FStoNumber",jzMessage.getJzCode());
        //设置基站地址
        model.put("FStoAddress",jzMessage.getProjectAddress());
        basic.put("Model", model);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("formid", formid);
        jsonObject.put("data", JSON.toJSONString(basic));
        return JSON.toJSONString(jsonObject);
    }

    /**
     * 构造提交、审核参数
     *
     * @param formid  表单id
     * @param numbers 编码 多个编码以,分隔
     * @param numbers 审核标示 多个以,分隔 和编码一一对应
     * @return
     */
    public static String buildParam(String formid, String numbers, String flags) {
        JSONObject jsonObject = new JSONObject();
        JSONObject param = new JSONObject();
        if (flags != null) {
            String[] arr_flag = flags.split(",");
            param.put("InterationFlags", arr_flag);
        }
        String[] arr_number = numbers.split(",");
        param.put("Numbers", arr_number);
        jsonObject.put("formid", formid);
        jsonObject.put("data", JSON.toJSONString(param));
        return JSON.toJSONString(jsonObject);
    }

    /**
     * 构造获取合同参数
     *
     * @param formid      表单id
     * @param projectCode 项目编号
     * @param
     * @return
     */
    public static Map buileContract(String projectCode, String formid) {
        Map<String, Object> param = new HashMap<>();
        param.put("formid", formid);
        param.put("number", projectCode);
        return param;
    }
}

