
package org.rcisoft.business.processDesign.service.impl;

import org.rcisoft.business.jzmessage.common.TypeEnum;
import org.rcisoft.business.jzmessage.dao.JzMessageRepository;
import org.rcisoft.business.jzmessage.entity.JzMessage;
import org.rcisoft.business.processDesign.dao.WorkflowTemplateApproveHiRepository;
import org.rcisoft.business.processDesign.dao.WorkflowTemplateFormFieldHiRepository;
import org.rcisoft.business.processDesign.dao.WorkflowTemplateHiRepository;
import org.rcisoft.business.processDesign.dao.WorkflowTemplatePermissionHiRepository;
import org.rcisoft.business.processDesign.dto.TemplateMsgDTO;
import org.rcisoft.business.processDesign.dto.WorkTemplateResDTO;
import org.rcisoft.business.processDesign.entity.*;
import org.rcisoft.business.processDesign.service.ProcessService;
import org.rcisoft.common.BaseStationStatus;
import org.rcisoft.common.ProcessMapBpmn;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


/**
 * @Author: jiangpengpeng
 * @Description:
 * @Date: Created in 13:36  2019/7/29
 * @Modified By:
 */

@Service
@Transactional
public class ProcessServiceImpl implements ProcessService {
    @Autowired
    WorkflowTemplateHiRepository workflowTemplateHiRepository;
    @Autowired
    WorkflowTemplateFormFieldHiRepository workflowTemplateFormFieldHiRepository;
    @Autowired
    WorkflowTemplatePermissionHiRepository workflowTemplatePermissionHiRepository;
    @Autowired
    WorkflowTemplateApproveHiRepository workflowTemplateApproveHiRepository;
    @Autowired
    JzMessageRepository jzMessageRepository;

    //开始流程返回页面信息
    @Override
    public List<WorkflowTemplateFormFieldHi> startProcess(String typeTemplate) {
        List<WorkflowTemplateFormFieldHi> getFieldMes = workflowTemplateFormFieldHiRepository.getFieldMes(typeTemplate);
        return getFieldMes;
    }
    //拆站流程返回信息交维前或交维后
    @Override
    public List<WorkflowTemplateFormFieldHi> czStartProcess(String jzMessageId) {
        JzMessage jzMessage = jzMessageRepository.jzmessageByBusinessId(jzMessageId);
        if (jzMessage.getJzType().equals(TypeEnum.DJ.getkey())) {
            return startProcess(ProcessMapBpmn.BS_MAINTANCE_DOWN.getTypeTemplate());
        } else if (jzMessage.getJzType().equals(TypeEnum.TT.getkey())) {
            if (Integer.parseInt(jzMessage.getJzState()) > Integer.parseInt(BaseStationStatus.IT_WAIT_MAINTAIN.getCode())) {
                return startProcess(ProcessMapBpmn.BS_MAINTANCE_DOWN.getTypeTemplate());
            }
        } else if (jzMessage.getJzType().equals(TypeEnum.YD.getkey())) {
            if (Integer.parseInt(jzMessage.getJzState())>Integer.parseInt(BaseStationStatus.MC_WAIT_MAINTAIN.getCode())) {
                return startProcess(ProcessMapBpmn.BS_MAINTANCE_DOWN.getTypeTemplate());
            }
        }
        return startProcess(ProcessMapBpmn.BS_STAND_DOWN.getTypeTemplate());
    }
}

