package org.rcisoft.business.suser.service;

import org.rcisoft.business.suser.entity.JudgmentIdentity;
import org.rcisoft.business.suser.entity.SUser;
import org.rcisoft.business.suser.entity.SUserSYN;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.aop.CyPageUtil;
import org.rcisoft.sys.dept.entity.SysDept;

import java.util.List;

/**
 * Created by cy on 2019-8-5 15:25:04.
 */
public interface SUserService {

    /**
    * 保存 用户表
    * @param sUser
    * @return
    */
    CyPersistModel save(SUser sUser);

    /**
    * 删除 用户表
    * @param sUser
    * @return
    */
    CyPersistModel remove(SUser sUser);
    /**
    * 逻辑删除 用户表
    * @param sUser
    * @return
    */
    CyPersistModel removeLogical(SUser sUser);
    /**
    * 修改 用户表
    * @param sUser
    * @return
    */
    CyPersistModel merge(SUser sUser);

    /**
    * 根据id查询 用户表
    * @param id
    * @return
    */
    SUser findById(String id);

    /**
     * 根据id查询 用户姓名
     * @param id
     * @return
     */
    SUser findUserNameById(String id);

    /**
    * 分页查询 用户表
    * @param sUser
    * @return
    */
    List<SUser> findAllByPagination(CyPageUtil<SUser> paginationUtility,
                                    SUser sUser);


    /**
    * 查询list 用户表
    * @param sUser
    * @return
    */
    List<SUser> findAll(SUser sUser);

    /**
     * 查询当前部门下所有用户
     * @param deptId
     * @return
     */
    List<SUser> findAllUser(String deptId);
    /**
     * 返回维护部人员
     */
//    List<SUser> getMaintainPersonList();

    /**
     * 返回维护部人员
     */
    List<SUser> getMaintainPersonList();
    /**
     * 是不是管理员
     */
    Boolean isAdmin();

    /**
     *是否为导入导出管理员
     */
    JudgmentIdentity isSpecialIdentity();

    /**
     * 根据用户id查询用户和其对应的角色code
     * @return
     */
    List<SUser> queryRoleById(String businessId);


}
